
Redmine - Feature #39884

Allow multiple footnotes per single word

2023-12-20 04:09 - Mischa The Evil

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 5.0.8   

Resolution: Fixed   

Description

I stumbled upon this while trying to update RedmineInstall earlier today (v.336). The mention of "2.7" in the "Supported Ruby

versions" column on the "4.2" row in the "Ruby interpreter and supported databases" table needs to have a reference to footnote #1

too, but this seems in no way possible to achieve currently.

This was found on redmine.org so applies to the Textile formatter. I haven't tested this with other formatters.

Associated revisions

Revision 22546 - 2023-12-22 02:44 - Marius BĂLTEANU

Allow consecutive footnote references inTextile (#39884).

Patch by @hjust.

Revision 22547 - 2023-12-22 02:47 - Marius BĂLTEANU

Merge r22546 from trunk to 5.1-stable (#39884).

Revision 22548 - 2023-12-22 02:48 - Marius BĂLTEANU

Merge r22546 from trunk to 5.0-stable (#39884).

History

#1 - 2023-12-20 14:47 - Holger Just

- File 0001-Allow-consecutive-footnote-references-in-Textile-39884.patch added

The regular expression in Redcloth3#footnote_ref matches the following for footnote-references:

def footnote_ref( text )

  text.gsub!(/\b\[([0-9]+?)\](\s)?/,

    '<sup><a href="#fn\1">\1</a></sup>\2')

end

 Here, the \b requirements is effectively the same as a positive-lookbehind for a unicode word-character (A member of one of the following Unicode

general categories: Letter, Mark, Number, Connector_Punctuation), i.e. (?<=\p{Word}). This lookbehind rule however does not match the ] character

of the first footnote reference.

This might be fixed by including this character in the explicit lookbehind rule, i.e. by changing the regex from \b to (?<=[\p{Word}\]])

A full patch against Redmine trunk at r22537 is attached.

#2 - 2023-12-22 02:48 - Marius BĂLTEANU

- Status changed from New to Closed

- Assignee set to Marius BĂLTEANU

- Target version set to 5.0.8

- Resolution set to Fixed

Committed and merged to stable branches, thanks!
